<?php

/*

    Gavintech Framework
    Copyright (C) 2004-2007 Chris Kloosterman

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Author's Email Address:
        kloostec@gavintech.com
    Paper Mail:
        5945 Cassino Road
        Duncan, BC, V9L 4G5, Canada

*/

function ajax_print_table_list($edit) {

	# this is the only place where the ajax_edit variable is set
	# so that attackers can't modify a table they shoulddn't be able to
	# all edits should be checked against this variable
	if (!($_REQUEST["do_add"] && $_REQUEST["do_edit"])) {
		$_SESSION["ajax_edit"] = $edit;
	}

	$done_one = false;

	if (count($_SESSION["ajax_edit"]) > 1) {
		foreach ($_SESSION["ajax_edit"] as $key => $value) {
			if ($done_one) {
				echo ("&nbsp;|&nbsp;");
			}
			echo ("<a href=\"javascript:ajax_edit('".$key."')\">".$value["plural"]."</a>");
			$done_one = true;
		}
	} elseif (count($_SESSION["ajax_edit"]) == 1) {
		foreach ($_SESSION["ajax_edit"] as $key => $value) {
			$_REQUEST["id"] = $key;
		}
	}
?>
<div id="ajax_edit">
<?php
if (isset($_REQUEST["id"])) {
	print ajax_print_edit_page($_REQUEST["id"]);
}
?>
</div>
<?php
}

function ajax_print_edit_page($table_id) {
	
	if (!is_numeric($table_id) || !is_array($_SESSION["ajax_edit"][$table_id])) {
		puke("Table not allowed");
	}

	# we should attempt to add/edit when the form is submitted
	if ($_REQUEST["do_add"]) {
		ajax_do_add();
	}
	if ($_REQUEST["do_edit"]) {
		ajax_do_edit();
	}

	$return = "";

	$return .= "<form action=\"index.php\" method=\"post\">";
	$return .= "<input type=\"hidden\" name=\"next_page\" value=\"".clean_form_form($_SESSION["prev_page"])."\" />";
	$return .= "<input type=\"hidden\" name=\"id\" value=\"$table_id\" />";

	$table = $_SESSION["ajax_edit"][$table_id];
	
	print_errors();

	$return .= "<h2>Manage ".$table["plural"]."</h2>";
	$return .= "<table border=\"1\" style=\"border-collapse: collapse\"><tr>";

	$query_string = "";
	
	foreach ($table["fields"] as $key => $value) {
		$return .= "<th>".$value["name"]."</th>";
		if ($query_string != "") {
			$query_string .= ",";
		}
		$query_string .= $value["field"];
	}

	$key_field = $table["id_column"];

	$return .= "</tr>";

	$SQL = "SELECT $query_string FROM ".$table["table"];
	if ($table["filter"]) {
		$SQL .= " WHERE ".$table["filter"];
	}
	$result = sql_query_read($SQL);

	while ($row = sql_fetch_array($result)) {
		$return .= "<tr>";
		foreach ($table["fields"] as $key => $value) {
			if ($value["type"] == 0 || $value["type"] == 1) {
				$return .= "<td>".clean_sql_display($row[$value["field"]])."</td>";
			} elseif ($value["type"] == 2) {
				$return .= "<td><input name=\"edit[".$value["field"]."][".$row[$key_field]."]\" type=\"text\" value=\"".clean_sql_form($row[$value["field"]])."\" /></td>";
			} elseif ($value["type"] == 3) {
				$return .= "<td>".display_date_dropdown($row[$value["field"]], "edit[".$value["field"]."][".$row[$key_field]."]", "both", true)."</td>";
			} elseif ($value["type"] == 4) {
				if ($row[$value["field"]] == 'Y') {
					$checked = " checked=\"checked\"";
				} else {
					$checked = "";
				}
				$return .= "<td><input type=\"checkbox\" name=\"edit[".$value["field"]."][".$row[$key_field]."]\" $checked /></td>";
			} elseif ($value["type"] == 5) {
				$return .= "<td>".display_date_dropdown($row[$value["field"]], "edit[".$value["field"]."][".$row[$key_field]."]", "date", true)."</td>";
			}
		}
		$return .= "</tr>";
	}

	$return .= "</table>";
	
	$return .= "<p><input type=\"submit\" name=\"do_edit\" value=\"Save\" /></p>";

	$return .= "</form>";

	$return .= "<form action=\"index.php\" method=\"post\">";
	$return .= "<input type=\"hidden\" name=\"next_page\" value=\"".clean_form_form($_SESSION["prev_page"])."\" />";
	$return .= "<input type=\"hidden\" name=\"id\" value=\"$table_id\" />";

	$return .= "<h2>Add ".$table["name"]."</h2>";

	$return .= "<table>";
	foreach ($table["fields"] as $key => $value) {
		if ($value["type"] == 4) {
			$return .= "<tr><td>".$value["name"]."</td><td><input type=\"checkbox\" name=\"add[".$value["field"]."]\" /></td></tr>";
		} elseif ($value["type"] == 3) {
			$return .= "<tr><td>".$value["name"]."</td><td>".display_date_dropdown(time(), "add[".$value["field"]."]", "both", true)."</td></tr>";
		} elseif ($value["type"] == 5) {
			$return .= "<tr><td>".$value["name"]."</td><td>".display_date_dropdown(time(), "add[".$value["field"]."]", "date", true)."</td></tr>";
		} elseif ($value["type"] > 0) {
			$return .= "<tr><td>".$value["name"]."</td><td><input type=\"text\" name=\"add[".$value["field"]."]\" value=\"\" /></td></tr>";
		}
	}
	$return .= "</table>";

	$return .= "<p><input type=\"submit\" name=\"do_add\" value=\"Add\" /></p>";
	$return .= "</form>";
	
	return $return;
}

function ajax_do_edit() {

	global $errors;
	global $successes;

	$table = $_SESSION["ajax_edit"][$_REQUEST["id"]];

	$update_fields = array();

	foreach ($table["fields"] as $key => $value) {
		# this is an updatable field
		if ($value["type"] >= 2) {
			array_push($update_fields, $value);
		}
	}

	$key_field = $table["id_column"];

	# we're going to do this the safe way
	# find the ids that we should be updating
	# and update from the list of updatable fields
	$SQL = "SELECT $key_field FROM ".$table["table"];
	if ($table["filter"]) {
		$SQL .= " WHERE ".$table["filter"];
	}
	$result = sql_query_read($SQL);
	$success = 0;
	while ($row = sql_fetch_array($result)) {
		$field_array = array();
		$update_array = array();

		# assume it validated
		$validated = 1;
		foreach ($update_fields as $key => $value) {
			$field = clean_form_neutral($_REQUEST["edit"][$value["field"]][$row[$key_field]]);
			if ($value["validator"]) {
				if (!preg_match("/".$value["validator"]."/", $field)) {
					$validated = 0;
					$errors[] = $value["name"]." could not be set to ".clean_neutral_display($field)." (reason: ".$value["error"].")";
					break;
				}
			}
			$field_array[] = $value["field"];
			if ($value["type"] == 2) {
				$update_array[] = $field;
			} elseif ($value["type"] == 3 || $value["type"] == 5) {
				$update_array[] = Format::dateToTime($_REQUEST["edit"][$value["field"]][$row[$key_field]]);
			} elseif ($value["type"] == 4) {
				if ($_REQUEST["edit"][$value["field"]][$row[$key_field]]) {
					$update_array[] = 'Y';
				} else {
					$update_array[] = 'N';
				}
			}
		}

		$update_array[] = $row[$key_field];
		if ($validated) {
			$stmt = sql_build_manip($table["table"], $field_array, MDB2_AUTOQUERY_UPDATE, "$key_field = ?");
			$successful = sql_execute_manip($stmt, $update_array);
			if ($successful) {
				$success++;
			} else {
				$errors[] = "Error updating ID number ".$row[$key_field];
			}
		}
	}
	if ($success > 0) {
		$successes[] = $success." row".($success == 1 ? "" : "s")." edited";
	}
}

function ajax_do_add() {
	
	global $errors;
	global $successes;

	$table = $_SESSION["ajax_edit"][$_REQUEST["id"]];

	$update_fields = array();

	foreach ($table["fields"] as $key => $value) {
		# this is an updatable field
		if ($value["type"] > 0) {
			array_push($update_fields, $value);
		}
	}

	$key_field = $table["id_column"];

	# we're going to do this the safe way...
	# insert from the list of updatable fields
	# assume it worked
	$validated = 1;

	$id = sql_next_id($table["table"]);
	if (isset($_REQUEST["add"][$table["id_column"]])) {
		$field_array = array();
		$insert_array = array();
	} else {
		$field_array = array($table["id_column"]);
		$insert_array = array($id);
	}

	foreach ($update_fields as $key => $value) {
		if ($value["validator"]) {
			if (!preg_match("/".$value["validator"]."/", clean_form_neutral($_REQUEST["add"][$value["field"]]))) {
				$validated = 0;
				$errors[] = $value["name"]." could not be set to ".clean_neutral_display($_REQUEST["add"][$value["field"]])." (reason: ".$value["error"].")";
				break;
			}
		}
		$field_array[] = $value["field"];
		if ($value["type"] == 2) {
			$insert_array[] = clean_form_neutral($_REQUEST["add"][$value["field"]]);
		} elseif ($value["type"] == 3 || $value["type"] == 5) {
			$insert_array[] = Format::dateToTime($_REQUEST["add"][$value["field"]]);
		} elseif ($value["type"] == 4) {
			if ($_REQUEST["add"][$value["field"]]) {
				$insert_array[] = 'Y';
			} else {
				$insert_array[] = 'N';
			}
		}
	}

	if ($validated) {
		$stmt = sql_build_manip($table["table"], $field_array, MDB2_AUTOQUERY_INSERT, NULL);
		$successful = sql_execute_manip($stmt, $insert_array);
		if ($successful) {
			$successes[] = "Row added";
		} else {
			$errors[] = "Error adding row";
		}
	}
}

?>
