<?php

/*

    Gavintech Framework
    Copyright (C) 2004-2007 Chris Kloosterman

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Author's Email Address:
        kloostec@gavintech.com
    Paper Mail:
        5945 Cassino Road
        Duncan, BC, V9L 4G5, Canada

*/

function print_domain_selector() {

	$SQL = "SELECT domain_id, name FROM domain WHERE user_id = ".clean_form_sql($_SESSION["user_id"])." ORDER BY name";
	$result = sql_query_read($SQL);

	if (sql_num_rows($result) < 1) {
		puke ("No domains found for this user!");
	} elseif (sql_num_rows($result) == 1) {
		# default to the only domain found, don't show the dropdown
		$row = sql_fetch_array($result);
		$_SESSION["domain_id"] = $row["domain_id"];
	} else {
		# more than one domain found, show the dropdown, defaulting to the one already chosen
		echo ("<h2>Choose a domain</h2>");
		echo ("<form action=\"index.php\" method=\"get\">\n");
		echo ("<input type=\"hidden\" name=\"next_page\" value=\"".clean_form_form($_REQUEST["next_page"])."\" />");
		echo ("<select name=\"domain_id\">\n");
		while ($row = sql_fetch_array($result)) {
			$selected = ($row["domain_id"] == $_SESSION["domain_id"]) ? " selected=\"selected\"" : "";
			echo ("<option$selected value=\"".$row["domain_id"]."\">".clean_sql_display($row["name"])."</option>\n");
		}
		echo ("</select>\n");
		echo ("<br /><br />\n");
		echo ("<input type=\"submit\" value=\"Choose domain\" />");
		echo ("</form>\n");
	}
}

function print_email_selector() {

	$SQL = "SELECT email_id, email.name, domain.name as domain_name FROM email INNER JOIN domain ON (domain.domain_id = email.domain_id)  WHERE email.user_id = ".clean_form_sql($_SESSION["user_id"])." AND domain.domain_id = ".clean_form_sql($_SESSION["domain_id"])." ORDER BY name";
	$result = sql_query_read($SQL);

	if (sql_num_rows($result) < 1) {
		echo ("<p>No email accounts for this domain!</p>");
	} elseif (sql_num_rows($result) == 1) {
		# default to the only domain found, don't show the dropdown
		$row = sql_fetch_array($result);
		$_SESSION["email_id"] = $row["email_id"];
	} else {
		# more than one domain found, show the dropdown, defaulting to the one already chosen
		echo ("<h2>Choose an email address</h2>");
		echo ("<form action=\"index.php\" method=\"get\">\n");
		echo ("<input type=\"hidden\" name=\"next_page\" value=\"".clean_form_form($_REQUEST["next_page"])."\" />");
		echo ("<select name=\"email_id\">\n");
		while ($row = sql_fetch_array($result)) {
			$selected = ($row["email_id"] == $_SESSION["email_id"]) ? " selected=\"selected\"" : "";
			echo ("<option$selected value=\"".$row["email_id"]."\">".clean_sql_display($row["name"])."@".clean_sql_display($row["domain_name"])."</option>\n");
		}
		echo ("</select>\n");
		echo ("<br /><br />\n");
		echo ("<input type=\"submit\" value=\"Choose address\" />");
		echo ("</form>\n");
	}
}

function dropdown($name, $options, $default, $do_return = false, $width="", $javascript="", $multiple = false) {
	if ($multiple != false) {
		$multiple_str = " multiple=\"multiple\" size=\"$multiple\"";
	}
	$dropdown = "<select name=\"$name\" ".($width == "" ? "" : "style=\"width: ".$width."px\"")." $javascript $multiple_str>";
	foreach ($options as $value) {
		if (is_array($value)) {
			if (is_array($default)) {
				if (array_search($value["id"], $default) !== false) {
					$selected = " selected=\"selected\"";
				} else {
					$selected = "";
				}
			} else {
				if (strtolower($value["id"]) == strtolower($default)) {
					$selected = " selected=\"selected\"";
				} else {
					$selected = "";
				}
			}
			$dropdown .= "<option$selected value=\"".clean_sql_form($value["id"])."\">".clean_sql_display(ucfirst($value["name"]))."</option>\n";
		} else {
			if (is_array($default)) {
				if (array_search($value, $default) !== false) {
					$selected = " selected=\"selected\"";
				} else {
					$selected = "";
				}
			} else {
				if (strtolower($value) == strtolower($default)) {
					$selected = " selected=\"selected\"";
				} else {
					$selected = "";
				}
			}
			$dropdown .= "<option$selected value=\"".clean_sql_form(ucfirst($value))."\">".clean_sql_display(ucfirst($value))."</option>\n";
		}
	}
	$dropdown .= "</select>";
	
	if ($do_return) {
		return($dropdown);
	} else {
		echo ($dropdown);
	}
}

function encodeToUtf8($string) {
     return mb_convert_encoding($string, "UTF-8", mb_detect_encoding($string, "UTF-8, ISO-8859-1, ISO-8859-15", true));
}

function encodeToIso($string) {
	$text = iconv("UTF-8", 'ISO-8859-1//TRANSLIT', $string);
	return $text;
}

?>
