<?php

/*

    Gavintech Framework - A base for PHP projects
    Copyright (C) 2004-2008 Chris Kloosterman

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Author's Email Address:
        kloostec@gavintech.com
    Paper Mail:
        5945 Cassino Road
        Duncan, BC, V9L 4G5, Canada

*/

##################
# Initialization #
##################

# stuff to do when the page starts
# - start the page generation time counter
# - initialize the sql query counter
load("page_start.php");

# initialize multibyte stuff
load("multibyte.php");

# global variables
load("vars.php");
load("version.php");

# session initialization stuff
load("session.php");

# functions that every page will use
load("error_functions.php");
load("clean_functions.php");
load("date_functions.php");
load("paginate_functions.php");
load("ajax_functions.php");
load("data_functions.php");
load("ticketing_functions.php");
load("email_functions.php");
load("javascript_functions.php");
load("log_functions.php");
load("gtphoto_functions.php");
load("graph_functions.php");
load("captcha_functions.php");

# sql wrappers for database functions (so that we can change db servers)
load("sql_wrappers.php");

# classes for the complex objects
load("class_loader.php");

# start the database connection
load("database.php");

?>
