<?php

/*

    Gavintech Framework
    Copyright (C) 2004-2007 Chris Kloosterman

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Author's Email Address:
        kloostec@gavintech.com
    Paper Mail:
        5945 Cassino Road
        Duncan, BC, V9L 4G5, Canada

*/

# expects that message and component are already clean
function add_log($message, $component="no component", $level=FRAMEWORK_LOG_INFO) {

	if ($level <= FRAMEWORK_LOG_LEVEL) {

		if (LOG_TYPE == "database") {
			$id = sql_next_id("log");
			if (isset($_SESSION["user_id"])) {
				$field_array = array("log_id", "log_date", "level", "user_id", "component", "ip", "message");
				$insert_array = array($id, time(), $level, $_SESSION["user_id"], $component, $_SERVER["REMOTE_ADDR"], $message);
			} else {
				$field_array = array("log_id", "log_date", "level", "component", "ip", "message");
				$insert_array = array($id, time(), $level, $component, $_SERVER["REMOTE_ADDR"], $message);
			}
			$stmt = sql_build_manip("log", $field_array, MDB2_AUTOQUERY_INSERT, NULL);
			# special: don't log log entries
			sql_execute_manip($stmt, $insert_array, false);
		} elseif (LOG_TYPE == "syslog") {
			global $done_one_log;
			if (!$done_one_log) {
				define_syslog_variables();
				openlog(SHORT_NAME, LOG_PID, LOG_USER);
				$done_one_log = 1;
			}

			$msg = "User: ".stripslashes($_SESSION["user_name"]).", Component: $component, IP: ".$_SERVER["REMOTE_ADDR"].", Message: $message";

			$lvl = LOG_DEBUG;
			if ($level == FRAMEWORK_LOG_DEBUG) {
				$lvl = LOG_DEBUG;
			} elseif ($level == FRAMEWORK_LOG_INFO) {
				$lvl = LOG_INFO;
			} elseif ($level == FRAMEWORK_LOG_NOTICE) {
				$lvl = LOG_NOTICE;
			} elseif ($level == FRAMEWORK_LOG_WARN) {
				$lvl = LOG_WARNING;
			} elseif ($level == FRAMEWORK_LOG_ERROR) {
				$lvl = LOG_ERR;
			} else {
				puke ("Invalid log level");
			}

			syslog($lvl, $msg);
		}
	}

}

?>
