<?php

/*

    Gavintech Framework - A base for PHP projects
    Copyright (C) 2004-2008 Chris Kloosterman

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Author's Email Address:
        kloostec@gavintech.com
    Paper Mail:
        5945 Cassino Road
        Duncan, BC, V9L 4G5, Canada

*/

# this is the module that does logins from the database

function do_login() {

	# do a SHA256 hash of the user's password
	$password = mhash(MHASH_SHA256,$_REQUEST["password"]);
	# generate a 64 byte hex representation of the above
	$password = bin2hex($password);

	$SQL = "SELECT user_id
		FROM ".sql_quote_identifier("user")."
		WHERE user_name = ".clean_form_sql($_REQUEST["user_name"])."
		AND password = ".sql_escape($password);
	$result = sql_query_read($SQL);
	if (sql_num_rows($result) > 0) {
		$row = sql_fetch_array($result);
		$_SESSION["user_name"] = $_REQUEST["user_name"];
		$_SESSION["user_id"] = $row["user_id"];
		
		# set up user perms
		$_SESSION["types"] = array();
		$SQL = "SELECT type_id from user_type_link WHERE user_id = ".clean_form_sql($_SESSION["user_id"])." ORDER BY type_id";
		$result = sql_query_read($SQL);
		if (sql_num_rows($result) > 0) {
			while ($row = sql_fetch_array($result)) {
				array_push($_SESSION["types"], $row["type_id"]);
			}
		}
	} else {
		global $errors;
		$errors[] = "Authentication failed";
	}
}

?>
