<?php

/*

    Gavintech Framework - A base for PHP projects
    Copyright (C) 2004-2008 Chris Kloosterman

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Author's Email Address:
        kloostec@gavintech.com
    Paper Mail:
        5945 Cassino Road
        Duncan, BC, V9L 4G5, Canada

*/

# this file contains code to execute right when the page starts

# it requires the function get_microtime(), which must be
# in this file, as functions will not have been included yet,
# and we want to start timing before any code is executed

#############
# Functions #
#############

# function: get_microtime
# input: none
# return: the time since the unix epoch, including milliseconds
# description: change the microtime() function into something useful
function get_microtime() {
	# microtime is a really stupid function
	# it returns the time as the decimal point,
	# then the integer part separated by a space
	$time_array = explode(" ", microtime());
	return($time_array[0] + $time_array[1]);
}

########
# Code #
########

# the time we started rendering the page
global $PAGE_START_TIME;
$PAGE_START_TIME = get_microtime();

# count the number of SQL queries, for statistics later
global $total_sql_queries;
$total_sql_queries = 0;

?>
