<?php

/*

    Gavintech Framework - A base for PHP projects
    Copyright (C) 2004-2008 Chris Kloosterman

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Author's Email Address:
        kloostec@gavintech.com
    Paper Mail:
        5945 Cassino Road
        Duncan, BC, V9L 4G5, Canada

*/

load("sidebar_definition.php");

function do_sidebar() {

	global $sidebar_items;

	$output = "<table width=\"100%\">\n";
	$output .= (is_array($sidebar_items) ? do_sidebar_recurse($sidebar_items, 0, "") : "");
	$output .= "</table>\n";

	return $output;

}

function do_sidebar_recurse($sidebar_items, $level, $output) {
	# figure out the get string
	$get_string = "?";
	$get_string .= get_string_recursive($_GET,"");
	if ($_POST["next_page"]) {
		$get_string .= "next_page=".clean_form_url($_POST["next_page"])."&amp;";
	}
	# this section defines a sidebar.
	# go through each item in the array, and spit out its link (or links)
	foreach ($sidebar_items as $key => $value) {
		# left hand spaces
		$spaces = "&nbsp;";
		for ($i = 0; $i < $level; $i++) {
			$spaces .= "&nbsp;&nbsp;&nbsp;&nbsp;";
		}
		$header_spaces = "&nbsp;";
		for ($i = 0; $i < $level; $i++) {
			$header_spaces .= "&nbsp;&nbsp;&nbsp;&nbsp;";
		}
		if (is_array($value)) {
			# figure out whether to expand or contract menus
			if ($_REQUEST["expand"] == $key) {
				$_SESSION["expand"][$key] = true;
			}
			if ($_REQUEST["hide"] == $key) {
				$_SESSION["expand"][$key] = false;
			}
			# don't do check_under_recurse, because it breaks really easily right now
			$minus_gif = "minus.gif";
			# actually draw out the heading
			if ($_SESSION["expand"][$key] == true) {
				if (NO_AJAX_SIDEBAR) {
					$output .= "<tr><td class=\"navmenulink\">$header_spaces<a href=\"".$_SERVER["REQUEST_URL"].$get_string."hide=".urlencode($key)."\"><img src=\"media/images/$minus_gif\" border=\"0\" alt=\"[-]\" /></a>&nbsp;<a href=\"".$_SERVER["REQUEST_URL"].$get_string."hide=".urlencode($key)."\"><b>".str_replace(" ","&nbsp;",$key)."</b></a></td></tr>\n";
				} else {
					$output .= "<tr><td class=\"navmenulink\">$header_spaces<a href=\"javascript:ajax_menu('hide','".urlencode($key)."')\"><img src=\"media/images/$minus_gif\" border=\"0\" alt=\"[-]\" /></a>&nbsp;<a href=\"javascript:ajax_menu('hide','".urlencode($key)."')\"><b>".str_replace(" ","&nbsp;",$key)."</b></a></td></tr>\n";
				}
				# overwrite with the result of recursion
				$output = do_sidebar_recurse($value,$level + 1, $output);
			} else {
				if (NO_AJAX_SIDEBAR) {
					$output .= "<tr><td class=\"navmenulink\">$header_spaces<a href=\"".$_SERVER["REQUEST_URL"].$get_string."expand=".urlencode($key)."\"><img src=\"media/images/plus.gif\" border=\"0\" alt=\"[+]\" /></a>&nbsp;<a href=\"".$_SERVER["REQUEST_URL"].$get_string."expand=".urlencode($key)."\"><b>".str_replace(" ","&nbsp;",$key)."</b></a></td></tr>\n";
				} else {
					$output .= "<tr><td class=\"navmenulink\">$header_spaces<a href=\"javascript:ajax_menu('expand','".urlencode($key)."')\"><img src=\"media/images/plus.gif\" border=\"0\" alt=\"[+]\" /></a>&nbsp;<a href=\"javascript:ajax_menu('expand','".urlencode($key)."')\"><b>".str_replace(" ","&nbsp;",$key)."</b></a></td></tr>\n";
				}
			}
		} else {
			if ($value != "(form)") {
				$key_nbsp = str_replace(" ","&nbsp;",$key);
			}
			if ($value=="(blank)") {
				# blank space
				$output .= "<tr><td class=\"navmenulink\">&nbsp;</td></tr>\n";
			} else if ($value=="(line)") {
				# line
				$output .= "<tr><td class=\"navmenulink\">&nbsp;<img src=\"media/images/blue.gif\" width=\"160\" height=\"1\" align=\"middle\" alt=\"\" /></td></tr>\n";
			} else if ($value=="(form)") {
				# form
				$output .= "<tr><td class=\"navmenulink\"><form action=\"index.php\">$spaces$key</form></td></tr>\n";
			} else if ($value=="") {
				# heading
				$output .= "<tr><td class=\"navmenulink\"><span class=\"highlight2\">$spaces$key_nbsp</span></td></tr>\n";
			} else {
				# don't highlight
				$output .= "<tr><td class=\"navmenulink\">$spaces<a href=\"$value\">$key_nbsp</a></td></tr>\n";
			}
		}
	}

	return $output;
}

function get_string_recursive($array,$brackets) {
        foreach ($array as $key => $value) {
                # hack to get hide and expand to not be carried over
                # but not to get rid of the "0" element of arrays
                # (which was happening accidentally)
                if ($brackets == "" && ($key == "hide" || $key == "expand")) {
                        continue;
                }
                if (is_array($value)) {
                        if ($brackets == "") {
                                $temp = $key;
                        } else {
                                $temp = $brackets . "[$key]";
                        }
                        $get_string .= get_string_recursive($array[$key],$temp);
                } else {
                        if ($brackets == "") {
                                $temp = $key;
                        } else {
                                $temp = $brackets . "[$key]";
                        }
                        $get_string .= $temp . "=" . urlencode($value) . "&amp;";
                }
        }
        return $get_string;
}

?>
