<?php

/*

    Gavintech Framework - A base for PHP projects
    Copyright (C) 2004-2008 Chris Kloosterman

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Author's Email Address:
        kloostec@gavintech.com
    Paper Mail:
        5945 Cassino Road
        Duncan, BC, V9L 4G5, Canada

*/

global $sidebar_items;

if (is_array($_SESSION["types"])) {
	
	if (defined('AUTH_USER') && array_search(AUTH_USER, $_SESSION["types"]) !== false) {
		$sidebar_items["Todo List"]["View current items"] = "index.php?next_page=todo/list.php";
		$sidebar_items["Todo List"]["Add item"] = "index.php?next_page=todo/add.php";
	}

	if (defined('AUTH_ADMIN') && array_search(AUTH_ADMIN, $_SESSION["types"]) !== false) {
		$sidebar_items["Administration"]["Query log"] = "index.php?next_page=log/view.php";
		$sidebar_items["Administration"]["Interesting page log"] = "index.php?next_page=log/view.php&submit=Search&do_component=true&component=Page%20Log";
		$sidebar_items["Administration"]["Page log exclusions"] = "index.php?next_page=log/exclusions.php";
		$sidebar_items["Administration"]["Documentation"] = "index.php?next_page=docs/index.php";
	}

	if (defined('AUTH_TICKETING_CONSULTANT') && array_search(AUTH_TICKETING_CONSULTANT, $_SESSION["types"]) !== false) {
		$sidebar_items["Ticketing"]["New Ticket"] = "index.php?next_page=ticketing/new_ticket.php";
		$sidebar_items["Ticketing"]["Quick Search"] = "index.php?next_page=ticketing/quick_search.php";
		$sidebar_items["Ticketing"]["Person Search"] = "index.php?next_page=ticketing/person_search.php";
		$sidebar_items["Ticketing"]["Problem Search"] = "index.php?next_page=ticketing/problem_search.php";
		$sidebar_items["Ticketing"]["Manage Data"] = "index.php?next_page=ticketing/manage.php";
		$sidebar_items["Ticketing"]["Ticket #<input type=\"text\" name=\"ticket_id\" style=\"width: 25px\" />&nbsp;<input type=\"submit\" value=\"Go\" /><input type=\"hidden\" name=\"next_page\" value=\"ticketing/show_ticket.php\" />"] = "(form)";

	}

	if (defined('AUTH_USER') && array_search(AUTH_USER,$_SESSION["types"]) !== false) {
		$sidebar_items["Manage Account"]["Update Info"] = "index.php?next_page=account/info.php";
		$sidebar_items["Manage Account"]["Change Password"] = "index.php?next_page=account/password.php";
		$sidebar_items["Manage Account"]["Payments"] = "index.php?next_page=account/payments.php";
	}

	if (defined('AUTH_USER') && array_search(AUTH_USER, $_SESSION["types"]) !== false) {
		$sidebar_items["Shopping Cart"] = "index.php?next_page=cart.php";
	}

	# rss feeds
	if (defined('AUTH_USER') && array_search(AUTH_USER, $_SESSION["types"]) !== false) {
		# find all of the categories that the user is subscribed to
		$SQL = "SELECT rss_category.rss_category_id, rss_category.name as category_name
			FROM rss_category
			INNER JOIN rss_subscription ON (rss_category.rss_category_id = rss_subscription.rss_category_id)
			WHERE rss_subscription.user_id = ".clean_form_sql($_SESSION["user_id"])."
			GROUP BY rss_category.rss_category_id, category_name
			HAVING count(rss_subscription_id) > 0";
		$result = sql_query_read($SQL);
		
		# go through each category and find the feeds in that category
		while ($row = sql_fetch_array($result)) {
			$SQL = "SELECT rss.name AS name, rss.rss_id
				FROM rss
				INNER JOIN rss_subscription ON (rss.rss_id = rss_subscription.rss_id)
				WHERE rss_category_id = ".clean_sql_sql($row["rss_category_id"])."
				AND rss_subscription.user_id = ".clean_form_sql($_SESSION["user_id"]);
			$result2 = sql_query_read($SQL);
			
			# keep track of the feeds
			# (so that we can provide a total number of new messages
			# for the entire category at the end)
			$feeds = array();
			$new_count = 0;
			
			while ($row2 = sql_fetch_array($result2)) {
			
				# find the number of unread messages in this feed
				$SQL = "SELECT COUNT(rss_item.rss_item_id) AS count
					FROM rss
					INNER JOIN rss_item ON (rss_item.rss_id = rss.rss_id)
					LEFT JOIN rss_read ON (rss_item.rss_item_id = rss_read.rss_item_id AND rss_read.user_id = ".$_SESSION["user_id"].")
					WHERE rss.rss_id = ".clean_sql_sql($row2["rss_id"])."
					AND rss_read.rss_read_id IS NULL
					AND rss_item.hidden = 0
					GROUP BY rss.rss_id";
				$result3 = sql_query_read($SQL);
				$row3 = sql_fetch_array($result3);

				if (is_array($row3)) {
					$c = $row3["count"];
				} else {
					$c = 0;
				}

				# hack: if we've been asked to mark all items as read
				# and we're about to display that feed, we should display a count of zero
				# even though we haven't actually marked the items as read yet
				if ($_REQUEST["mark"] && $_REQUEST["rss_id"] == $row2["rss_id"]) {
					$c = 0;
				}

				if (strlen($row2["name"]) > 15) {
					$feed_name = substr($row2["name"], 0, 15)."... ($c)";
				} else {
					$feed_name = $row2["name"]." ($c)";
				}
				$feeds[$feed_name] = "index.php?next_page=rss/view_feed.php&rss_id=".$row2["rss_id"];
				$new_count += $c;
			}

			# can't do this because we lose the sidebar expansion
			#$sidebar_items["Feeds"][$row["category_name"]." ($new_count)"] = $feeds;
			
			$sidebar_items["Feeds"][$row["category_name"]] = $feeds;
		}
		
		$sidebar_items["Feeds"]["Manage My Feeds"] = "index.php?next_page=rss/feeds.php";
	}
}

?>
