<?php

/*

    Gavintech Framework - A base for PHP projects
    Copyright (C) 2004-2008 Chris Kloosterman

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Author's Email Address:
        kloostec@gavintech.com
    Paper Mail:
        5945 Cassino Road
        Duncan, BC, V9L 4G5, Canada

*/

function display_consultant_dropdown($name, $default="") {
	$SQL = "SELECT name, consultant_id FROM ticket_consultant ORDER BY name";
	$result = sql_query_read($SQL);
	while ($row = sql_fetch_array($result)) {
		$option = array();
		$option["id"] = $row["consultant_id"];
		$option["name"] = $row["name"];
		$options[] = $option;
	}
	dropdown($name, $options, $default, false, 300);
}

function display_status_dropdown($name, $default="") {
	$SQL = "SELECT name, status_id FROM ticket_status ORDER BY name";
	$result = sql_query_read($SQL);
	while ($row = sql_fetch_array($result)) {
		$option = array();
		$option["id"] = $row["status_id"];
		$option["name"] = $row["name"];
		$options[] = $option;
	}
	dropdown($name, $options, $default, false, 300);
}

function print_tickets($result) {
	if (sql_num_rows($result) == 0) {
		echo ("<p><i>No results found</i></p>");
	} elseif (sql_num_rows($result) == 1) {
		$row = sql_fetch_array($result);
		header ("Location: index.php?next_page=ticketing/show_ticket.php&ticket_id=".$row["ticket_id"]);
		exit();
	} else {
		$array = array();
		while ($row = sql_fetch_array($result)) {
			$array2 = array();

			$array2["Number"][0] = $row["ticket_id"];
			if ($row["date_closed"] == null) {
				$ss = "";
				$se = "";
			} else {
				$ss = "<s>";
				$se = "</s>";
			}
			$array2["Number"][1] = "$ss<a href=\"index.php?next_page=ticketing/show_ticket.php&ticket_id=".$row["ticket_id"]."\">".$row["ticket_id"]."</a>$se";
			$array2["Status"] = str_replace(" ", "&nbsp;", $row["status_name"]);
			$array2["Summary"] = $row["summary"];
			$array2["Charge"][0] = $row["charge"];
			$array2["Charge"][1] = "\$".number_format($row["charge"], 2, '.', '');
			$array2["Time&nbsp;spent"] = number_format($row["time_spent"], 2, '.', '');

			$array[] = $array2;
		}
		$carry = generate_carry(array('status_id', 'type'));
		paginate($array, "Number", SORT_ASC, 50, "Summary", $carry);
	}
}

?>
