<?php

/*

    Gavintech Framework - A base for PHP projects
    Copyright (C) 2004-2008 Chris Kloosterman

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Author's Email Address:
        kloostec@gavintech.com
    Paper Mail:
        5945 Cassino Road
        Duncan, BC, V9L 4G5, Canada

*/

# this script stores all of the global variables for the site

# database constants
define('READ_DATABASE_SERVER', "(your_read_db_server)");
define('READ_DATABASE_USER', "(your_read_db_user)");
define('READ_DATABASE_PASSWORD', "(your_read_db_user_password)");

define('WRITE_DATABASE_SERVER', "(your_write_db_server)");
define('WRITE_DATABASE_USER', "(your_write_db_user)");
define('WRITE_DATABASE_PASSWORD', "(your_write_db_user_password)");

define('DEFAULT_DATABASE', "(your_db_name)");

# change to mysqli if you're using a MySQL 4.1+ database rather than postgres
define('DATABASE_TYPE', "pgsql");
#define('DATABASE_TYPE', "mysqli");

# ldap specific parameters
#define('LDAP_SERVER', "(ldap server)");
#define('LDAP_UID', "(ldap bind uid)");
#define('LDAP_PASSWORD', "(ldap bind password)");
#define('LDAP_SEARCH_BASE', "(ldap search base)");

# are we debugging?
define('DEBUG', 0);

# site modifiers
define('IS_PRODUCTION', false);
define('DO_CACHING', true);
define('READ_ONLY_MODE', false);

# puke stuff
define('PUKE_EMAIL', "(who_to_email_if_framework_pukes)");
define('PUKE_FROM', "(who_puke_email_is_from)");
define('EMAIL_AUTO_FROM', "(who_automated_emails_are_from)");

# authentication levels
define('AUTH_ADMIN', 99);
define('AUTH_TICKETING_CONSULTANT', 51);
define('AUTH_USER', 1);

global $standard_types;
$standard_types = array(AUTH_USER);

define('FRAMEWORK_LOG_ERROR', 10);
define('FRAMEWORK_LOG_WARN', 20);
define('FRAMEWORK_LOG_NOTICE', 30);
define('FRAMEWORK_LOG_INFO', 40);
define('FRAMEWORK_LOG_DEBUG', 50);

define('FRAMEWORK_LOG_LEVEL', FRAMEWORK_LOG_INFO);

# the modules to use
# Login Module - which method to use to login
# possibilities:
# - db.php: via database
# - ldap.php: via ldap
define('MODULE_LOGIN', "db.php");

# the error handling arrays
global $errors;
global $warnings;
global $successes;
$errors = array();
$warnings = array();
$successes = array();

# here are paths to dynamically import classes from
global $class_dirs;
$class_dirs = array("./framework/classes");

# here are paths to dynamically import rpc functionality from
global $rpc_dirs;
$rpc_dirs = array("./framework/rpc");

# should we allow signups
define('ALLOW_SIGNUP', 1);

# should we disable AJAX sidebar?
define('NO_AJAX_SIDEBAR', 0);
#define('NO_AJAX_PAGINATE', 1);

# font for GD images
define('GD_FONT', "framework/fonts/arial.ttf");

# change to 'syslog' for logging to syslog
define('LOG_TYPE', "database");

# the name of this framework
define('FRAMEWORK_NAME', 'Gavintech Framework');
define('SHORT_NAME', 'Framework');

?>
